#!/bin/bash

# bash ~/src/BasePairingScore_Fold.sh -f ~/Documents/scientific/HIV-HiR/2nd/refgenome/NL4.3.fasta -N pNL4.3_vius_HIV_virusRNA -b 455 -e 810  -n 100 -s NC_BPS.txt  -t 100 -a NC


# optimize: rank the constrains :priority for long arm
export PATH=$PATH:/Users/yan/DownloadedApps/comrades-master/bin

# parsing command line options
while getopts "f:b:e:N:n:s:t:a:" OPTION
do
     case $OPTION in
         f) REF_FASTA=$OPTARG ;;
         b) BEGIN=$OPTARG ;;
         e) END=$OPTARG ;;
         N) Name_RNA=$OPTARG ;;
         n) NUM_CONSTRAINTS=$OPTARG ;;
		 s) BASEPAIR_SCORES=$OPTARG ;;
         t) Number_CTs=$OPTARG ;;
         a) Alias=$OPTARG ;;
         ?)
             echo "incorrect option"
             exit 0
             ;;
     esac
done



REF_TAB="ref.tab"

FRAGMENT_SCORES=${BASEPAIR_SCORES}


RANKED_INTERACTIONS="${BASEPAIR_SCORES/.txt/}_ranked_interactions.txt"
FOLDING_CONSTRAINTS=${RANKED_INTERACTIONS/ranked_interactions.txt/folding_constraints.txt}

# converting basepair scores to folding constraints

sort -k3,3nr $FRAGMENT_SCORES | bp2hyb.sh | awk 'BEGIN {FS="\t";OFS="\t"}; $3 >1 && $8 > $7+3 {print $0}' > $RANKED_INTERACTIONS # keep only long and high abundant interactions

hyb2constraints.pl $RANKED_INTERACTIONS | awk -v b=$BEGIN -v n=$NUM_CONSTRAINTS 'NR<=n{print $1 "\t" $2-(b-1) "\t" $3-(b-1) "\t" $4-1}' > $FOLDING_CONSTRAINTS


# preparing reference files
fasta2tab.awk $REF_FASTA > $REF_TAB
FASTA=${Name_RNA}_${BEGIN}_${END}_${Alias}.fasta


awk -v b=$BEGIN -v e=$END -v Name_RNA=${Name_RNA} 'BEGIN{FS="\t"} $1==Name_RNA {print ">" $1 ":" b "-" e "\n" substr($2,b,e-b+1)}' $REF_TAB > $FASTA


# comrades fold

#bash basePairFold.V2.sh -c $FOLDING_CONSTRAINTS -i $FASTA -t $Number_CTs
bash basePairFold.sh -c $FOLDING_CONSTRAINTS -i $FASTA -t $Number_CTs

# # compare dG and total score of CT; calculate mapcolor(base-score for each base in each CT)

