#!/bin/bash

# bash BasePairing_Fold.sh -f ../refgenome/NL4.3.fasta -b 7787 -e 7962 -N pNL4.3_vius_HIV_virusRNA -n 75 -s HIV5-1 -d base_pairing

export PATH=$PATH:/Users/yan/DownloadedApps/comrades-master/bin

# parsing command line options
while getopts "f:b:e:n:s:N:d:" OPTION
do
     case $OPTION in
         f) REF_FASTA=$OPTARG ;;
         b) BEGIN=$OPTARG ;;
         e) END=$OPTARG ;;
         N) Name_RNA=$OPTARG ;;
         n) NUM_CONSTRAINTS=$OPTARG ;;
		 s) BASEPAIR_SCORES=$OPTARG ;;
         d) Dir_results=$OPTARG ;;
         ?)
             echo "incorrect option"
             exit 0
             ;;
     esac
done

BASEPAIR_FULLPATH=../comrades_score/${BASEPAIR_SCORES}/${BASEPAIR_SCORES}.basepair_scores.txt

REF_TAB="ref.tab"


cat ${BASEPAIR_FULLPATH} > ${Dir_results}/"BASEPAIR_SCORES.txt"
FRAGMENT_SCORES="fragment_scores.txt"

RANKED_INTERACTIONS="${Name_RNA}_${BEGIN}_${END}_ranked_interactions.txt"
FOLDING_CONSTRAINTS=${RANKED_INTERACTIONS/ranked_interactions.txt/folding_constraints.txt}

# converting basepair scores to folding constraints
cd $Dir_results
awk -v b=$BEGIN -v e=$END '$1>=b && $1<=e && $2>=b && $2<=e{print $0}' BASEPAIR_SCORES.txt > $FRAGMENT_SCORES
awk -f ../merge_BPScore_orientation.awk $FRAGMENT_SCORES  >"merged."$FRAGMENT_SCORES
sort -k1,1n -k2,2n "merged."$FRAGMENT_SCORES > "merged.sort."$FRAGMENT_SCORES
cat "merged.sort."$FRAGMENT_SCORES | bp2hyb.sh > $RANKED_INTERACTIONS
hyb2constraints.pl $RANKED_INTERACTIONS | awk -v b=$BEGIN -v n=$NUM_CONSTRAINTS 'NR<=n{print $1 "\t" $2-(b-1) "\t" $3-(b-1) "\t" $4}' > $FOLDING_CONSTRAINTS


# preparing reference files
fasta2tab.awk ../$REF_FASTA > $REF_TAB
awk -v b=$BEGIN -v e=$END 'BEGIN{FS="\t"}{print ">" $1 "\n" substr($2,b,e-b+1)}' $REF_TAB > ${BASEPAIR_SCORES}_${Name_RNA}_${BEGIN}_${END}.fasta


# comrades fold

 comradesFold -c $FOLDING_CONSTRAINTS -i ${BASEPAIR_SCORES}_${Name_RNA}_${BEGIN}_${END}.fasta 


# calculate total base pair score for each structure

# for (( i=1; i<=3; i++ )); do
#     dG=

# done

