#!/bin/bash

# options
#SAMPLES=(L3 L4 L7 L8 L15 L16)
SAMPLES=(L12)
#SAMPLES=(test)
DB=NL4.3_hOH7.gz
RNA=pNL4.3_vius_HIV_virusRNA
export HYB_DB=../../refgenome



# make_hyb_db ../refgenome/GX002_hOH7.fasta.gz


mkdir ../hyb_PEAR
cd ../hyb_PEAR

for FILE in ${SAMPLES[*]};do



	mkdir $FILE
	cd $FILE

    # pear
    echo -ne `pear -e -j 32 -f ../../Cleandata/${FILE}/${FILE}_R2.fastq.gz -r ../../Cleandata/${FILE}/${FILE}_R1.fastq.gz -o ${FILE}.PEAR >pear.log`

    # merge
	echo -ne `cat $FILE.PEAR.assembled.fastq $FILE.PEAR.unassembled.forward.fastq $FILE.PEAR.unassembled.reverse.fastq  > $FILE.PEAR.fastq`
    echo -ne `rm -rf $FILE.PEAR.assembled.fastq $FILE.PEAR.unassembled.forward.fastq $FILE.PEAR.unassembled.reverse.fastq $FILE.PEAR.discarded.fastq`

    # fastp clipping
	echo -ne `fastp -i $FILE.PEAR.fastq -o $FILE.PEAR.fastp.fastq -h fastp.html -w 4 -a AGATCGGAAGAGCGTCG >fastp.log`


    #ln $FILE.PEAR.fastq $FILE.PEAR.fastp.fastq
        # hyb detect

            # hyb detect
	echo -ne `hyb detect in=$FILE.PEAR.fastp.fastq db=$DB qc=none  >hyb.log`

    echo -ne `rm -rf $FILE.PEAR.fastp.fastq `

	# gzip usefull files
	
	
	echo -ne `cat $FILE.PEAR.fastp_comp_$DB.blast |gzip > $FILE.PEAR_comp_$DB.blast.gz`

	echo -ne `cat $FILE.PEAR.fastp_comp_${DB}_hybrids.fasta |gzip > $FILE.PEAR_comp_${DB}_hybrids.fasta.gz`
	echo -ne `echo $(wc -l $FILE.PEAR.fastp_comp_${DB}_hybrids_ua.hyb) $(wc -l $FILE.PEAR.fastp_comp_${DB}_hybrids.hyb ) > $FILE.PEAR_comp_${DB}_hyb.stats.txt`	

	# remove useless files

    echo -ne `rm -rf $FILE.PEAR.fastq $FILE.PEAR_clipped_qf.fastq $FILE.PEAR_clipped_qf.tab $FILE.PEAR_comp.fasta ${FILE}_comp_$DB.blast $FILE.PEAR_comp_${DB}_hybrids.fasta `
	echo -ne `rm -rf $FILE.PEAR.fastp_comp_$DB.blast $FILE.PEAR.fastp_comp_$DB_mtophits.blast `
	echo -ne `rm -rf $FILE.PEAR.fastp_comp_${DB}_mtophits.ref $FILE.PEAR.fastp_comp_$DB_mtophits.blast $FILE.PEAR.fastp_comp_${DB}_singleE.blast`
	echo -ne `rm -rf $FILE.PEAR.fastp_comp_${DB}_hybrids.hyb`

        cd ..
done



