#!/bin/bash
# this is a script to find base pair score of each base pair in given .CT structure

# example :
# colorCT_2fragment.sh -i NL43-731-745.fa-NL43-2145-2162.fa.ct -b 731 -e 745 -B 2145 -E 2162 -d . -s BPS_merged_NC.txt -a NC 

# parsing command line options
while getopts "i:b:e:B:E:s:d:a:" OPTION
do
     case $OPTION in
         i) INPUT_CT=$OPTARG ;;
         b) Bait_BEGIN=$OPTARG ;;
         e) Bait_END=$OPTARG ;;
         B) Target_Begin=$OPTARG ;;
         E) Target_End=$OPTARG ;;
		 s) BASEPAIR_SCORES=$OPTARG ;;
         d) Dir_basepair_score=$OPTARG ;;
		 a) Alias_of_basepair_score=$OPTARG ;;
         ?)
             echo "incorrect option"
             exit 0
             ;;
     esac
done

BASEPAIR_FULLPATH=${Dir_basepair_score}/${BASEPAIR_SCORES}
CORLORMAP=${INPUT_CT/.ct/}".colormap."${BASEPAIR_SCORES}".txt"
modifed_CT=${INPUT_CT/.ct/.modifed.ct}


FRAGMENT_SCORES=${BASEPAIR_FULLPATH}


# calculate score
CORLORMAP=${INPUT_CT/.ct/}".colormap."${Alias_of_basepair_score}".txt"
modifed_CT=${INPUT_CT/.ct/.mod.ct}
rm -f $CORLORMAP 


awk  -v Bait_BEGIN=${Bait_BEGIN} -v Bait_END=${Bait_END} -v Target_Begin=${Target_Begin} -v Target_End=${Target_End} -f ~/src/parse_2frag_CT.awk $INPUT_CT > temp.ct
cat temp.ct | while read CT_bit1 CT_bit2; do
    awk -v CT_bit1=${CT_bit1} -v CT_bit2=${CT_bit2} -v B=${BEGIN} -f ~/src/scoreCT.awk $FRAGMENT_SCORES >> $CORLORMAP
  #  awk -v CT_bit1=${CT_bit1} -v CT_bit2=${CT_bit2}  -f ~/src/scoreCT_bin.awk $FRAGMENT_SCORES >> $CORLORMAP
done 

Total_score=`awk 'BEGIN{total=0;FS="\t"} {total=total+$2}END{print total}' $CORLORMAP`
awk -v Bait_BEGIN=${Bait_BEGIN} -v Bait_END=${Bait_END} -v Target_Begin=${Target_Begin} -v Target_End=${Target_End} -v Total_score=${Total_score} 'BEGIN{OFS="\t";FS="\t"} /dG/{print $0,Total_score};!/dG/{if($1 <= Bait_END-Bait_BEGIN+1){
 $6=$6+Bait_BEGIN-1} else {
 $6=$6+Target_Begin-1
 } print $1,$2,$3,$4,$5,$6,$7,$8}' $INPUT_CT > $modifed_CT

#rm -f temp.ct
#rm -f temp.ct 